{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

unit BASScode;

{$mode objfpc}{$H+}

interface

uses LCLIntf, WinVersion, Graphics, Classes, lightBASS;

var
 BASSFFTType:DWORD;
 BASSFFTNoWin:DWORD;
 BASSFFTRemDC:DWORD;
 BASSAmpMin:real;
 BASSNetUseProxy:boolean;
 BASSNetAgent,BASSNetProxy:string;

 procedure GetNetConfig;
 procedure StartBASS(DLL:TBassDll);
 procedure BASSVisualisation;
 procedure BASS_SetLoop;

implementation

uses MainWin, {$IFDEF Windows}WaveOutAPI,{$ENDIF Windows} Players, Mixer;

procedure BASSVisualisation;
var
 i,l,r,k:DWORD;
 q:QWORD;
 fft:array of single;
 spa:array[0..spa_num-1] of single;
 k1,l1:real;
begin
if (MusicHandle = 0) or Paused then exit;
  q := BASS_ChannelGetPosition(MusicHandle,BASS_POS_BYTE); if q = QWORD(-1) then exit;
  if StreamIsUser then
   AYVisualisation(DivMul(q,8,Int64(NumberOfChannels) * Int64(SampleBit)))
  else
   begin
    k1 := BASS_ChannelBytes2Seconds(MusicHandle,q); if k1 < 0 then exit;
    CurrTime_Rasch := trunc(k1 * 1000);
    if (CurFileType in [StreamFileMin..StreamFileMax]) and (StreamPlayFrom > 0) then
     Dec(CurrTime_Rasch,StreamPlayFrom);
    VProgrPos := CurrTime_Rasch;
    if IndicatorChecked then
     begin
      l := BASS_ChannelGetLevel(MusicHandle);
      if l <> $FFFFFFFF then
       begin
        r := l shr 16;
        if r <= BASSAmpMin * 128 then
         r := 0
        else
         r := trunc(32768/ln(1/BASSAmpMin)*ln(r/BASSAmpMin/32768)+0.5);
        l := l and $FFFF;
        if l <= BASSAmpMin * 128 then
         l := 0
        else
         l := trunc(32768/ln(1/BASSAmpMin)*ln(l/BASSAmpMin/32768)+0.5);
        RedrawVisChannels(l,0,r,32768)
       end
     end;
    if SpectrumChecked then
     begin
      case BASSFFTType of
      BASS_DATA_FFT256: k := 256;
      BASS_DATA_FFT512: k := 512;
      BASS_DATA_FFT1024: k := 1024;
      BASS_DATA_FFT2048: k := 2048;
      BASS_DATA_FFT4096: k := 4096;
      BASS_DATA_FFT8192: k := 8192;
      BASS_DATA_FFT16384: k := 16384;
      else k := 32768;
      end;
      SetLength(fft,k div 2);
      k1 := spa_num/ln(20000/20);
      l := BASS_ChannelGetData(MusicHandle,@fft[0],BASSFFTType or BASSFFTNoWin or BASSFFTRemDC); if l = $FFFFFFFF then exit;
      BMP_Vis.Canvas.CopyMode:=cmSrcCopy;
      BMP_Vis.Canvas.CopyRect(Rect(0,0,spa_width,spa_height),BMP_Sources.Canvas,Bounds(spa_src,0,spa_width,spa_height));
{      for i := 1 to k div 2 - 1 do
       begin
        r := round(k1 * ln(i/k/20*SampleRate));
        if r < spa_num then
         begin
          if fft[i] <= BASSAmpMin then
           l := spa_height
          else
           l := round(spa_height - spa_height/ln(1/BASSAmpMin)*ln(fft[i]/BASSAmpMin));
          if l < spa_height then
           begin
            BMP_Vis.Canvas.MoveTo(r,spa_height);
            BMP_Vis.Canvas.LineTo(r,l + 1);
           end
         end
       end; }

      FillChar(spa,spa_num*sizeof(single),0);
      for i := 1 to k div 2 - 1 do
         begin
          r := trunc(k1 * ln(i/k/20*SampleRate)+0.5);
          if r < spa_num then
           spa[r] := spa[r] + fft[i]*fft[i];
         end;
      fft := nil;

      for r := 0 to spa_num-1 do
       begin
        l1 := sqrt(spa[r]);
        if l1 > BASSAmpMin then
         begin
          l1 := spa_height - spa_height/ln(1/BASSAmpMin)*ln(l1/BASSAmpMin);
          if l1 >= 0 then
           begin
            BMP_Vis.Canvas.MoveTo(r,spa_height);
            BMP_Vis.Canvas.LineTo(r,trunc(l1+0.5) + 1);
           end;
         end
       end;

      Form1.Canvas.CopyMode:=cmSrcCopy;
      Form1.Canvas.CopyRect(Bounds(spa_x,spa_y,spa_width,spa_height),BMP_Vis.Canvas,Rect(0,0,spa_width,spa_height));
     end;
    ShowProgress(VProgrPos);
   end;
end;

procedure GetNetConfig;
var
 p:pointer;
begin
if BASSNetAgent = '' then
 begin
  BASSNetAgent := PChar(BASS_GetConfigPtr(BASS_CONFIG_NET_AGENT));
  Form2.NetAgentCB.Text := BASSNetAgent;
  p := BASS_GetConfigPtr(BASS_CONFIG_NET_PROXY);
  BASSNetUseProxy := p <> nil;
  Form2.ProxyE.Enabled := BASSNetUseProxy;
  Form2.ProxyChk.Checked := BASSNetUseProxy;
  if BASSNetUseProxy then
   begin
    BASSNetProxy := PChar(p);
    Form2.ProxyE.Text := BASSNetProxy;
   end;
 end;
end;

procedure StartBASS(DLL:TBassDll);
begin
 if IsPlaying then exit;
 PlayFreeBASS;
 LoadBASS(DLL);

 InitBASS({BASS_FIRSTSOUNDDEVICE}BASS_DEFAULTDEVICE,SampleRate,0,Form1.Handle);

 IsPlaying := True;
 {$IFDEF Windows}
 Reseted := 0;
 {$ENDIF Windows}
 Paused := False;
 {$IFNDEF Windows}

 if CurFileType in [BASSFileMin..BASSFileMax] then
  begin
 {$ENDIF Windows}
   PlayBASS(PChar(ValidateFileName(UTF8Decode(CurItem.FileName))),CurFileType in [StreamFileMin..StreamFileMax],DLL,StreamPlayFrom,Time_ms);
   if FileIsURL(CurItem.FileName) then PostMessage(Form1.Handle,WM_BASSMETADATA,0,0);
 {$IFNDEF Windows}
  end
 else if CurFileType in [MinAYChipFile..MaxAYChipFile] then
  PlayBASS(nil,True,DLL,-1,Time_ms);
 {$ENDIF Windows}
end;

procedure BASS_SetLoop;
var
 info:BASS_CHANNELINFO;
begin
if MusicHandle = 0 then exit;
if (CurFileType in [StreamFileMin..StreamFileMax]) and (StreamPlayFrom >= 0) then exit;
BASS_ChannelGetInfo(MusicHandle,info);
if Do_Loop then
 begin
  RemoveSync;
  info.flags := info.flags or BASS_SAMPLE_LOOP
 end
else
 begin
  if CurrTime_Rasch >= Time_ms then
   begin
    PostMessage(Form1.Handle,WM_PLAYNEXTITEM,0,0);
    exit
   end;
  SetSync;
  info.flags := info.flags and (BASS_SAMPLE_LOOP xor DWORD(-1));
 end;
BASS_ChannelFlags(MusicHandle,info.flags,info.flags);
end;

end.
