{
lighttlhelp32
-------------
(c)2008,2016 S.V.Bulba
http://bulba.untergrund.net/
svbulba@gmail.com

Description:
------------
Based on TlHelp32.pas from Delphi 7

}

unit lighttlhelp32;

{$mode objfpc}{$H+}

interface

uses
  Windows, Classes, SysUtils, win32proc;

type
 PROCESSENTRY32 = packed record
  dwSize: DWORD;
  cntUsage: DWORD;
  th32ProcessID: DWORD;       // this process
  th32DefaultHeapID: DWORD;
  th32ModuleID: DWORD;        // associated exe
  cntThreads: DWORD;
  th32ParentProcessID: DWORD; // this process's parent process
  pcPriClassBase: Longint;    // Base priority of process's threads
  dwFlags: DWORD;
  szExeFile: array[0..MAX_PATH - 1] of Char;// Path
 end;

 PROCESSENTRY32W = packed record
  dwSize: DWORD;
  cntUsage: DWORD;
  th32ProcessID: DWORD;          // this process
  th32DefaultHeapID: ULONG_PTR;
  th32ModuleID:DWORD;            // associated exe
  cntThreads: DWORD;
  th32ParentProcessID: DWORD;    // this process's parent process
  pcPriClassBase: LONG;          // Base priority of process's threads
  dwFlags: DWORD;
  szExeFile: array [0..MAX_PATH - 1] of WCHAR;// Path
 end;

const
 TH32CS_SNAPPROCESS  = $00000002;

function Inittlhelp32:boolean;

var
 CreateToolhelp32Snapshot: function (dwFlags, th32ProcessID: DWORD): THandle; stdcall;
 Process32First: function (hSnapshot: THandle; var lppe: PROCESSENTRY32): BOOL; stdcall;
 Process32Next: function (hSnapshot: THandle; var lppe: PROCESSENTRY32): BOOL; stdcall;
 Process32FirstW: function (hSnapshot: THandle; var lppe: PROCESSENTRY32W): BOOL; stdcall;
 Process32NextW: function (hSnapshot: THandle; var lppe: PROCESSENTRY32W): BOOL; stdcall;

implementation

var
 KernelHandle:THandle = 0;

function TryGet(const p:pointer):pointer;
begin
Result := p;
if p = nil then RaiseLastOSError;
end;

function Inittlhelp32:boolean;
begin
Result := False;
KernelHandle := GetModuleHandle('kernel32.dll');
if KernelHandle <> 0 then
 begin
 pointer(CreateToolhelp32Snapshot) := TryGet(GetProcAddress(KernelHandle, 'CreateToolhelp32Snapshot'));
  if UnicodeEnabledOS then
   begin
    pointer(Process32FirstW) := GetProcAddress(KernelHandle, 'Process32FirstW');
    pointer(Process32NextW) := GetProcAddress(KernelHandle, 'Process32NextW');
   end
  else
   begin
    pointer(Process32First) := GetProcAddress(KernelHandle, 'Process32First');
    pointer(Process32Next) := GetProcAddress(KernelHandle, 'Process32Next');
   end;
 end;
Result := True;
end;

end.

