{
This is part of AY Emulator project
AY-3-8910/12 Emulator
Version 2.9 for Windows and Linux
Author Sergey Vladimirovich Bulba
(c)1999-2016 S.V.Bulba
}

unit WinVersion;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Dialogs, LCLIntf, LCLType, lazutf8,
  {$IFDEF Windows}
  Windows, win32proc, lighttlhelp32,
  {$ELSE Windows}
  process,
  {$ENDIF Windows}
  Types;

{$IFDEF Windows}
const
//FileMapping
 arealen = (MAX_PATH * 2 + 4) * 2;
 DdeServiceName = 'Ay_Emul';
{$ENDIF Windows}

  function GetCommandLine:string;
  function FileIsURL(FileName:string):boolean;
  function ProcessExists:boolean;
  {$IFDEF Windows}
  procedure StartDDE;
  procedure StopDDE;
  function ValidateDirName(DN:WideString):string;
  {$endif Windows}
  function ValidateFileName(FN:WideString):string;
  {$IFDEF Windows}
  function FileExists2(FN:string):boolean;
  procedure OpenInEditor;
  function GetTempFileName(const FN:string):string;
  procedure RenameTempFile(const FN,NewFN:string);
  function RegGetUTF8Value(subKeyHnd1:HKey):string;
  procedure RegSetUTF8Value(subKeyHnd1:HKey;s:string);
  {$ENDIF Windows}
  procedure RemoveTaskbarButton;
  procedure AddTaskbarButton;
  procedure CheckStringFitting(handle:THandle;var s:string;w:integer);
  function GetProcessFileName:string;
  {$IFNDEF Windows}
  procedure NonWin;
  {$ENDIF Windows}

implementation

{$IFDEF Windows}
uses
 MainWin,PlayList,Options;

 
const
 WindowTitle = 'AY-3-8910 & AY-3-8912 Emulator v2.9 Lazarus';
 TitleLength = Length(WindowTitle);

var
 HPrevWindow:HWnd;

function CheckParams:boolean;

type
 arr = packed array[0..arealen - 1] of byte;
var
 l:integer;
 T:DWORD;
 HBlock:longword;
 HAddr:^arr;
 s:string;
begin
Result := False;
T := GetTickCount;
repeat
HBlock := CreateFileMapping(longword(-1),nil,PAGE_READWRITE,0,arealen,'Ay_Emul Command Line Area');
if (HBlock <> 0) and (GetLastError = ERROR_ALREADY_EXISTS) then
 begin
  CloseHandle(HBlock);
  Sleep(1);
  HBlock := 0;
 end
until (HBlock <> 0) or (GetTickCount - T >= 5000);
if HBlock <> 0 then
 begin
  HAddr := MapViewOfFile(HBlock,FILE_MAP_ALL_ACCESS,0,0,arealen);
  if HAddr <> nil then
   begin
    Result := True;
    s := '"' + GetCurrentDirUTF8 + '" ' + GetCommandLine;
    if ParamCount = 0 then s := s + ' /vshow';
    l := Length(s);
    if l >= arealen then l := arealen - 1;
    move(s[1],HAddr^,l);
    HAddr^[l] := 0;
    SendMessage(HPrevWindow,WM_LINEPARAM,0,0);
    UnmapViewOfFile(HAddr);
   end;
  CloseHandle(HBlock);
 end;
end;

function EnumWindowsProc(hWnd,lParam:DWORD):BOOL;stdcall;
var
PID:DWORD;
s:string;
begin
Result := True;
GetWindowThreadProcessId(hWnd,@PID);
if PID = lParam then
 if GetWindowTextLength(hWnd) = TitleLength then
  begin
   SetLength(s,TitleLength + 1);
   GetWindowText(hWnd,PChar(s),TitleLength + 1);
   s := PChar(s);
   if s = WindowTitle then
    begin
     HPrevWindow := hWnd;
     Result := False;
    end;
  end;
end;
{$ENDIF Windows}

function ProcessExists:boolean;
{$IFDEF Windows}
var
 pe32:PROCESSENTRY32;
 pe32w:PROCESSENTRY32W;
 T,hSnapshot,CPID:DWORD;
 FN,FN2:string;
 ProcessFound:boolean;

begin
Result := False;

if not Inittlhelp32 then exit;

hSnapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);

if hSnapshot = DWORD(-1) then RaiseLastOSError;
try
 FN := UTF8LowerCase(ExtractFileName(GetProcessFileName));
 CPID := GetCurrentProcessId;
 if UnicodeEnabledOS then
  begin
   pe32w.dwSize := sizeof(PROCESSENTRY32W);
   ProcessFound := Process32FirstW(hSnapshot,pe32w);
  end
 else
  begin
   pe32.dwSize := sizeof(PROCESSENTRY32);
   ProcessFound := Process32First(hSnapshot,pe32);
  end;
  while ProcessFound do
   begin
     if UnicodeEnabledOS then
       pe32.th32ProcessID := pe32w.th32ProcessID;
     if pe32.th32ProcessID = CPID then exit;
     if UnicodeEnabledOS then
      FN2 := ExtractFileName(UTF8Encode(WideLowerCase(pe32w.szExeFile)))
     else
      FN2 := AnsiToUTF8(AnsiLowerCase(ExtractFileName(pe32.szExeFile)));
     if FN2 = FN then
      begin
       HPrevWindow := 0;
       T := GetTickCount;
       repeat
        EnumWindows(Windows.ENUMWINDOWSPROC(@EnumWindowsProc),pe32.th32ProcessID);
        if HPrevWindow = 0 then
         Sleep(1)
       until (HPrevWindow <> 0) or (GetTickCount - T >= 5000);
       if HPrevWindow <> 0 then Result := CheckParams;
       exit;
      end;
     if UnicodeEnabledOS then
      ProcessFound := Process32NextW(hSnapshot,pe32w)
     else
      ProcessFound := Process32Next(hSnapshot,pe32);
   end;
finally
 CloseHandle(hSnapshot);
end;
end;
{$ELSE Windows}
begin
  Result := False;
end;
(*
var
  t: TProcess;
  s: TStringList;
begin
  Result := 0;
  t := tprocess.Create(nil);
  t.CommandLine := 'ps -C ' + ExeName;
  t.Options := [poUsePipes, poWaitonexit];
    try
    t.Execute;
    s := TStringList.Create;
      try
      s.LoadFromStream(t.Output);
      Result := Pos(ExeName, s.Text);
      finally
      s.Free;
      end;
    finally
    t.Free;
    end;
end;*)
{$ENDIF Windows}

{$IFDEF Windows}
var
 DdeInst: Integer;

 function hsz2Str(Ahsz: HSZ): String;
 var
  L: Integer;
 begin
  Result := '';
  if Ahsz = 0 then exit;
  L := DdeQueryString(DdeInst, Ahsz, nil, 0, CP_WINANSI);
  if L <= 0 then exit;
  SetLength(Result, L);
  DdeQueryString(DdeInst, Ahsz, PChar(Result), L + 1, CP_WINANSI);
 end;

 function hDdeData2Str(AData: HDDEData): String;
 var
  L: Integer;
 begin
  Result := '';
  if AData = 0 then exit;
  L := DdeGetData(AData, nil, 0, 0);
  if L <= 0 then exit;
  SetLength(Result, L);
  DdeGetData(AData, PByte(PChar(Result)), L, 0);
  if UnicodeEnabledOS then
   Result := UTF8Encode(Widestring(PWideChar(Result)))
  else
   Result := AnsiToUTF8(PChar(Result));
 end;

 function DdeFunc(CallType, Fmt: UINT; Conv: HConv; hsz1, hsz2: HSZ;
  Data: HDDEData; Data1, Data2: DWORD): HDDEData stdcall;
 const
  SZDDESYS_TOPIC = 'System';
 begin
  Result := 0;
  case CallType of
    XTYP_CONNECT: begin
      if SameText(hsz2Str(hsz1), SZDDESYS_TOPIC)
      and SameText(hsz2Str(hsz2), DdeServiceName) then
        begin
         Result := 1;
        end;
    end;
    XTYP_EXECUTE: begin
      if SameText(hsz2Str(hsz1), SZDDESYS_TOPIC) then begin
        SetCommandLine('"' + GetCurrentDirUTF8 + '" Ay_Emul.exe ' + hDdeData2Str(Data));
        Result := DDE_FACK;
      end;
    end;
  end;
 end;

procedure StartDDE;
const
 CBF_SKIP_ALLNOTIFICATIONS = $003c0000;
begin
if UnicodeEnabledOS then
 begin
  DdeInitializeW(@DdeInst, @DdeFunc, APPCLASS_STANDARD or CBF_SKIP_ALLNOTIFICATIONS, 0);
 end
else
 begin
  DdeInitializeA(@DdeInst, @DdeFunc, APPCLASS_STANDARD or CBF_SKIP_ALLNOTIFICATIONS, 0);
 end;
DdeNameService(DdeInst, DdeCreateStringHandle(DdeInst, DdeServiceName, CP_WINANSI), 0, DNS_REGISTER);
end;

procedure StopDDE;
begin
DdeUninitialize(DdeInst);
end;

function GetShortName(WN:WideString):string;
var
 TmpW:WideString;
 Tmp:string;
 l:integer;
begin
Result := WN;
if UnicodeEnabledOS then
 begin
  SetLength(TmpW,MAX_PATH);
  l := GetShortPathNameW(PWideChar(WN),PWideChar(TmpW),MAX_PATH);
  if l > MAX_PATH then
   begin
    SetLength(Tmp,l);
    l := GetShortPathNameW(PWideChar(WN),PWideChar(TmpW),MAX_PATH);
   end;
  if l = 0 then exit;
  Result := PWideChar(TmpW);
 end
else
 begin
  SetLength(Tmp,MAX_PATH);
  l := GetShortPathNameA(PChar(Result),PChar(Tmp),MAX_PATH);
  if l > MAX_PATH then
   begin
    SetLength(Tmp,l);
    l := GetShortPathNameA(PChar(WN),PChar(Tmp),MAX_PATH);
   end;
  if l = 0 then exit;
  Result := PChar(Tmp);
 end;
end;

function ValidateDirName(DN:WideString):string;
begin
Result := DN;
if SysUtils.DirectoryExists(Result) then exit;
Result := GetShortName(DN);
end;

{$ENDIF Windows}

function ValidateFileName(FN:WideString):string;
begin
Result := FN;
{$IFDEF Windows}
if FileExists2(Result) then exit;
Result := GetShortName(FN);
{$ENDIF Windows}
end;

{$IFDEF Windows}

function FileExists2(FN:string):boolean;
var
 f:file;
begin
Result:=FileIsURL(FN); if Result then exit;
AssignFile(f,FN);
try
 System.Reset(f,1);
except
 Result := False;
 exit;
end;
CloseFile(f);
Result := True;
end;

{$ENDIF Windows}

function FileIsURL(FileName:string):boolean;
const
 nprotos=2;
 protos:array[0..nprotos]of string=
   ('http://','https://','ftp://');
var
 i:integer;
begin
FileName := LowerCase(FileName);
Result := True;
for i := 0 to nprotos do
 if (Pos(protos[i],FileName) = 1) then exit;
Result := False;
end;

function GetCommandLine:string;
{$IFDEF Windows}
begin
if UnicodeEnabledOS then
 Result := UTF8Encode(WideString(GetCommandLineW))
else
 Result := AnsiToUTF8(GetCommandLineA);
{$ELSE Windows}
var
 i:integer;
begin
Result := '"' + ParamStr(0) + '"';
for i := 1 to ParamCount do
 Result := Result + ' "' + ParamStr(i) + '"';
{$ENDIF Windows}
end;

{$IFDEF Windows}

procedure OpenInEditor; //todo: wide version
var
 SI:STARTUPINFO;
 PI:PROCESS_INFORMATION;
 FN:array of string;
 s:string;
 i,n:integer;
begin
n := 0; s := '';
for i := 0 to Length(PlaylistItems) - 1 do
 if PlayListItems[i]^.Selected then
  begin
   inc(n);
   SetLength(FN,n);
   FN[n - 1] := ValidateFileName(UTF8Decode(Form3.SaveFile(i,True)));
   s := s + ' "' + FN[n - 1] + '"';
  end;
if n = 0 then exit;
FillChar(SI,sizeof(SI),0);
SI.cb := sizeof(SI);
if not CreateProcess(PChar(VTPath),PChar(VTPath + s),
        nil,nil,False,0,nil,PChar(ExtractFileDir(VTPath)),SI,PI) then
 begin
  for i := n - 1 downto 0 do
   DeleteFile(PChar(FN[n]));
  RaiseLastOSError;
 end;
end;

function GetTempFileName(const FN:string):string;
var
// nm:string;
 nmw:widestring;
begin
Result := UTF8ToAnsi(FN);
if UnicodeEnabledOS then
 begin
  SetLength(nmw,MAX_PATH);
  if GetTempFileNameW(PWideChar(UTF8Decode(ExtractFileDir(FN))),'aye',0,PWideChar(nmw)) <> 0 then
   Result := GetShortName(PWideChar(nmw));
 end;
{else
 begin
  SetLength(nm,MAX_PATH);
  if GetTempFileNameA(PChar(UTF8ToAnsi(ExtractFileDir(FN))),'aye',0,PChar(nm)) <> 0 then
   Result := PChar(nm);
 end;}
end;

procedure RenameTempFile(const FN,NewFN:string);
var
 f1,f2:widestring;
begin
if not UnicodeEnabledOS then exit;
f1 := FN; f2 := UTF8Decode(NewFN); if WideCompareStr(f1,f2) = 0 then exit;
if not MoveFileExW(PWideChar(f1),PWideChar(f2),MOVEFILE_REPLACE_EXISTING) then RaiseLastOsError;
end;
{$ENDIF Windows}

procedure CheckStringFitting(handle:THandle;var s:string;w:integer);
var
 sz:TSize;
 len,nch:integer;
begin
len := Length(s); //в байтах - вроде фича LCL, а не баг
if not LCLIntf.GetTextExtentExPoint(handle,PChar(s),len,w,@nch,nil,Sz) then exit;
len := UTF8Length(s);
if nch < len then s := UTF8Copy(s,1,nch-3)+'...';
end;

{$IFDEF Windows}
function RegGetUTF8Value(subKeyHnd1:HKey):string;
var
 i,j,size:integer;
begin
Result := '';
if UnicodeEnabledOS then
 begin
  i := RegQueryValueExW(subKeyHnd1,nil,nil,@j,nil,@size);
  CheckRegError(i);
  if j = REG_SZ then
   begin
    SetLength(Result,size);
    i := RegQueryValueExW(subKeyHnd1,nil,nil,@j,@Result[1],@size);
    CheckRegError(i);
    Result := UTF8Encode(WideString(PWideChar(@Result[1])));
   end;
 end
else
 begin
  i := RegQueryValueExA(subKeyHnd1,nil,nil,@j,nil,@size);
  CheckRegError(i);
  if j = REG_SZ then
   begin
    SetLength(Result,size);
    i := RegQueryValueExA(subKeyHnd1,nil,nil,@j,@Result[1],@size);
    CheckRegError(i);
    Result := AnsiToUTF8(PChar(@Result[1]));
   end;
 end;
end;

procedure RegSetUTF8Value(subKeyHnd1:HKey;s:string);
var
 sw:widestring;
 i:integer;
begin
s := s + #0;
if UnicodeEnabledOS then
 begin
  sw := UTF8Decode(s); i := Length(sw)*2;
  i := RegSetValueExW(subKeyHnd1,nil,0,REG_SZ,PByte(@sw[1]),i);
  CheckRegError(i);
 end
else
 begin
  s := UTF8ToAnsi(s); i := Length(s);
  i := RegSetValueExA(subKeyHnd1,nil,0,REG_SZ,PByte(@s[1]),i);
  CheckRegError(i);
 end;
end;
{$ENDIF Windows}

function GetProcessFileName:string;
begin
Result := ParamStrUTF8(0);
end;

{$IFDEF Windows}
procedure Set_WS_EXSTYLE(h:THandle;WS:DWORD);
begin
ShowWindow(h,SW_HIDE);
SetWindowLong(h, GWL_EXSTYLE, WS);
ShowWindow(h,SW_SHOWNA);
end;
{$ENDIF Windows}

procedure RemoveTaskbarButton;
{$IFDEF Windows}
var
 h:THandle;
{$ENDIF Windows}
begin
{$IFDEF Windows}
h := GetParent(Form1.Handle);
Set_WS_EXSTYLE(h,GetWindowLong(h, GWL_EXSTYLE) and not WS_EX_APPWINDOW or WS_EX_TOOLWINDOW);
{$ENDIF Windows}
//todo in GTK2
end;

procedure AddTaskbarButton;
{$IFDEF Windows}
var
 h:THandle;
{$ENDIF Windows}
begin
{$IFDEF Windows}
h := GetParent(Form1.Handle);
Set_WS_EXSTYLE(h,GetWindowLong(h, GWL_EXSTYLE) and not WS_EX_TOOLWINDOW or WS_EX_APPWINDOW);
{$ENDIF Windows}
//todo in GTK2
end;

{$IFNDEF Windows}
procedure NonWin;
begin
MessageDlg('Supported in Windows version only',mtInformation,[mbOk],0);
end;
{$ENDIF Windows}

end.

